# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from naoqi_bridge_msgs/RobotInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class RobotInfo(genpy.Message):
  _md5sum = "cc8c56c1600e9f458ce3f2626800e77f"
  _type = "naoqi_bridge_msgs/RobotInfo"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# info here is inspired by http://doc.aldebaran.com/2-1/naoqi/motion/tools-general-api.html?highlight=getrobotconfig#ALMotionProxy::getRobotConfig

# enums describing the robot type
uint8 NAO=0
uint8 ROMEO=1
uint8 PEPPER=2

# one of NAO, ROMEO, PEPPER
uint8 type

# "Model Type"   : "naoH25", "naoH21", "naoT14" or "naoT2".
string model
# "Head Version" : "VERSION_32" or "VERSION_33" or "VERSION_40".
string head_version
# "Body Version" : "VERSION_32" or "VERSION_33" or "VERSION_40".
string body_version
# "Arm Version"  : "VERSION_32" or "VERSION_33" or "VERSION_40".
string arm_version

# "Laser"        : True or False.
bool has_laser
# "Extended Arms": True or False.
bool has_extended_arms

# Number of Legs : 0 or 2
int32 number_of_legs
# Number of Arms : 0 or 2
int32 number_of_arms
# Number of Hands: 0 or 2
int32 number_of_hands
"""
  # Pseudo-constants
  NAO = 0
  ROMEO = 1
  PEPPER = 2

  __slots__ = ['type','model','head_version','body_version','arm_version','has_laser','has_extended_arms','number_of_legs','number_of_arms','number_of_hands']
  _slot_types = ['uint8','string','string','string','string','bool','bool','int32','int32','int32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       type,model,head_version,body_version,arm_version,has_laser,has_extended_arms,number_of_legs,number_of_arms,number_of_hands

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RobotInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.type is None:
        self.type = 0
      if self.model is None:
        self.model = ''
      if self.head_version is None:
        self.head_version = ''
      if self.body_version is None:
        self.body_version = ''
      if self.arm_version is None:
        self.arm_version = ''
      if self.has_laser is None:
        self.has_laser = False
      if self.has_extended_arms is None:
        self.has_extended_arms = False
      if self.number_of_legs is None:
        self.number_of_legs = 0
      if self.number_of_arms is None:
        self.number_of_arms = 0
      if self.number_of_hands is None:
        self.number_of_hands = 0
    else:
      self.type = 0
      self.model = ''
      self.head_version = ''
      self.body_version = ''
      self.arm_version = ''
      self.has_laser = False
      self.has_extended_arms = False
      self.number_of_legs = 0
      self.number_of_arms = 0
      self.number_of_hands = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.type
      buff.write(_get_struct_B().pack(_x))
      _x = self.model
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.head_version
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.body_version
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.arm_version
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B3i().pack(_x.has_laser, _x.has_extended_arms, _x.number_of_legs, _x.number_of_arms, _x.number_of_hands))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.type,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.model = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.model = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.head_version = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.head_version = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.body_version = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.body_version = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.arm_version = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.arm_version = str[start:end]
      _x = self
      start = end
      end += 14
      (_x.has_laser, _x.has_extended_arms, _x.number_of_legs, _x.number_of_arms, _x.number_of_hands,) = _get_struct_2B3i().unpack(str[start:end])
      self.has_laser = bool(self.has_laser)
      self.has_extended_arms = bool(self.has_extended_arms)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.type
      buff.write(_get_struct_B().pack(_x))
      _x = self.model
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.head_version
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.body_version
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.arm_version
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B3i().pack(_x.has_laser, _x.has_extended_arms, _x.number_of_legs, _x.number_of_arms, _x.number_of_hands))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.type,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.model = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.model = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.head_version = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.head_version = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.body_version = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.body_version = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.arm_version = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.arm_version = str[start:end]
      _x = self
      start = end
      end += 14
      (_x.has_laser, _x.has_extended_arms, _x.number_of_legs, _x.number_of_arms, _x.number_of_hands,) = _get_struct_2B3i().unpack(str[start:end])
      self.has_laser = bool(self.has_laser)
      self.has_extended_arms = bool(self.has_extended_arms)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B3i = None
def _get_struct_2B3i():
    global _struct_2B3i
    if _struct_2B3i is None:
        _struct_2B3i = struct.Struct("<2B3i")
    return _struct_2B3i
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
